package immibis.ars.beams;

import immibis.core.BlockCombined;
import immibis.core.api.porting.SidedProxy;
import java.util.ArrayList;
import net.minecraft.server.ItemStack;
import net.minecraft.server.Material;
import net.minecraft.server.ModLoader;
import net.minecraft.server.TileEntity;

public class BlockBeamStuff extends BlockCombined
{
    public static int model;

    public BlockBeamStuff(int var1)
    {
        super(var1, Material.ORE, "/immibis/ars/textures/tesla.png");
        ModLoader.registerBlock(this, ItemBeamStuff.class);
        model = SidedProxy.instance.getUniqueBlockModelID("immibis.ars.beams.BlockRenderer", true);
    }

    private int getTextureBase(int var1)
    {
        switch (var1)
        {
            case 0:
                return 1;

            case 1:
                return 0;

            case 2:
                return 8;

            case 3:
                return 49;

            case 4:
                return 81;

            case 5:
                return 113;

            case 6:
                return 56;

            case 7:
                return 177;

            case 8:
                return 145;

            case 9:
                return 88;

            case 10:
                return 120;

            default:
                return 0;
        }
    }

    /**
     * From the specified side and block metadata retrieves the blocks texture. Args: side, metadata
     */
    public int a(int var1, int var2)
    {
        return var2 == 1 ? 16 : (var1 == 1 ? 16 : 0) + this.getTextureBase(var2) + var1;
    }

    public TileEntity getBlockEntity(int var1)
    {
        switch (var1)
        {
            case 0:
                return new TileUpgradeUnit();

            case 1:
                return new TileTeslaCoil();

            case 2:
                return new TileUpgradeCombiner();

            case 3:
                return new TileRangeUpgrade();

            case 4:
                return new TileEMPUpgrade();

            case 5:
                return new TileSpeedUpgrade();

            case 6:
                return new TileLootCollector();

            case 7:
                return new TileFieldFilter();

            case 8:
                return new TileInventoryContentsFilter();

            case 9:
                return new TileSuppressorUpgrade();

            case 10:
                return new TilePotionUpgrade();

            default:
                return null;
        }
    }

    public void addCreativeItems(ArrayList var1)
    {
        for (int var2 = 0; var2 < 11; ++var2)
        {
            var1.add(new ItemStack(this, 1, var2));
        }
    }
}
