package immibis.ars.beams;

import immibis.ars.mod_AdvancedRepulsionSystems;
import immibis.core.BasicInventory;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import net.minecraft.server.EntityHuman;
import net.minecraft.server.IInventory;
import net.minecraft.server.Item;
import net.minecraft.server.ItemPotion;
import net.minecraft.server.ItemStack;

public class TilePotionUpgrade extends TileBeamEmitter implements IInventory
{
    private BasicInventory inv = new BasicInventory(9);
    private UpgradeData upgrade = new UpgradeData();

    public TilePotionUpgrade()
    {
        this.upgrade.potions = Arrays.asList(new TilePotionUpgrade[] {this});
    }

    public Object getOutput()
    {
        return this.upgrade;
    }

    /**
     * Returns the number of slots in the inventory.
     */
    public int getSize()
    {
        return this.inv.contents.length;
    }

    /**
     * Returns the stack in slot i
     */
    public ItemStack getItem(int var1)
    {
        return this.inv.contents[var1];
    }

    /**
     * Decrease the size of the stack in slot (first int arg) by the amount of the second int arg. Returns the new
     * stack.
     */
    public ItemStack splitStack(int var1, int var2)
    {
        return this.inv.splitStack(var1, var2);
    }

    /**
     * When some containers are closed they call this on each slot, then drop whatever it returns as an EntityItem -
     * like when you close a workbench GUI.
     */
    public ItemStack splitWithoutUpdate(int var1)
    {
        return null;
    }

    /**
     * Sets the given item stack to the specified slot in the inventory (can be crafting or armor sections).
     */
    public void setItem(int var1, ItemStack var2)
    {
        this.inv.contents[var1] = var2;
    }

    /**
     * Returns the name of the inventory.
     */
    public String getName()
    {
        return "Potion upgrade";
    }

    /**
     * Returns the maximum stack size for a inventory slot. Seems to always be 64, possibly will be extended. *Isn't
     * this more of a set than a get?*
     */
    public int getMaxStackSize()
    {
        return 64;
    }

    /**
     * Do not make give this method the name canInteractWith because it clashes with Container
     */
    public boolean a(EntityHuman var1)
    {
        return var1.e((double)this.x + 0.5D, (double)this.y + 0.5D, (double)this.z + 0.5D) <= 64.0D;
    }

    public void f() {}

    public void g() {}

    public boolean onBlockActivated(EntityHuman var1)
    {
        if (!this.world.isStatic)
        {
            var1.openGui(mod_AdvancedRepulsionSystems.instance, 16, this.world, this.x, this.y, this.z);
        }

        return true;
    }

    public int getBeamColour()
    {
        return 1;
    }

    public List getEffect()
    {
        for (int var1 = 0; var1 < 9; ++var1)
        {
            ItemStack var2 = this.inv.contents[var1];

            if (var2 != null && var2.id == Item.POTION.id && ItemPotion.c(var2.getData()))
            {
                --var2.count;

                if (var2.count == 0)
                {
                    this.inv.contents[var1] = null;
                }

                this.update();
                return Item.POTION.b(var2);
            }
        }

        return Collections.emptyList();
    }
    
    @Override public ItemStack[] getContents() {return inv.contents;}
	@Override public void setMaxStackSize(int arg0) {}
}
