package immibis.ars.beams;

import ic2.api.Direction;
import ic2.api.ElectricItem;
import ic2.api.EnergyNet;
import ic2.api.IEnergySink;
import immibis.core.net.OneTwoFiveNetworking;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import net.minecraft.server.AxisAlignedBB;
import net.minecraft.server.DamageSource;
import net.minecraft.server.Entity;
import net.minecraft.server.EntityFallingBlock;
import net.minecraft.server.EntityHuman;
import net.minecraft.server.EntityItem;
import net.minecraft.server.EntityLiving;
import net.minecraft.server.EntityPainting;
import net.minecraft.server.EntityTNTPrimed;
import net.minecraft.server.ItemStack;
import net.minecraft.server.MobEffect;
import net.minecraft.server.NBTTagCompound;
import net.minecraft.server.PlayerInventory;
import net.minecraft.server.TileEntity;

public class TileTeslaCoil extends TileBeamEmitter implements IEnergySink
{
    private int filter_side = -1;
    private static final int MAX_STORAGE = 5000;
    private static final int MIN_SHOT_EU = 500;
    private static final int MIN_INTERVAL = 1;
    private static final int DEFAULT_INTERVAL = 20;
    private static final int DEFAULT_ITEM_INTERVAL = 3;
    private static final double DEFAULT_RANGE = 10.0D;
    private Set currentTargets = null;
    private Entity currentTarget = null;
    private int ticksToNextShot = 0;
    private int eu_stored = 0;
    private boolean addedToENet = false;
    private UpgradeData upgrades;
    private double RANGE;
    private static DamageSource damageSource = new DamageSource("ARSteslacoil")
    {
    };
    private static final int[] EMP_ARMOUR_PRIORITY = new int[] {2, 1, 3, 0};

    protected void setupBeams() {}

    public Object getOutput(int var1)
    {
        return null;
    }

    public void onBlockNeighbourChange()
    {
        super.onBlockNeighbourChange();
        this.filter_side = -1;
    }

    /**
     * Writes a tile entity to NBT.
     */
    public void b(NBTTagCompound var1)
    {
        super.b(var1);
        var1.setInt("energy", this.eu_stored);
    }

    /**
     * Reads a tile entity from NBT.
     */
    public void a(NBTTagCompound var1)
    {
        super.a(var1);
        this.eu_stored = var1.getInt("energy");
    }

    /**
     * Allows the entity to update its state. Overridden in most subclasses, e.g. the mob spawner uses this to count
     * ticks and creates a new spawn inside its implementation.
     */
    public void q_()
    {
        if (!this.world.isStatic)
        {
            if (!this.addedToENet)
            {
                EnergyNet.getForWorld(this.world).addTileEntity(this);
                this.addedToENet = true;
            }

            Object var2;

            if (this.filter_side == -1)
            {
                for (int var1 = 0; var1 < 6; ++var1)
                {
                    var2 = this.getInput(var1);

                    if (var2 instanceof EntityFilter)
                    {
                        this.filter_side = var1;
                        break;
                    }
                }
            }

            if (this.ticksToNextShot <= 0 && this.eu_stored >= 500)
            {
                EntityFilter var10;

                if (this.filter_side == -1)
                {
                    var10 = null;
                }
                else
                {
                    var2 = this.getInput(this.filter_side);

                    if (!(var2 instanceof EntityFilter))
                    {
                        var10 = null;
                    }
                    else
                    {
                        var10 = (EntityFilter)var2;
                    }
                }

                this.upgrades = new UpgradeData();

                for (int var11 = 0; var11 < 6; ++var11)
                {
                    Object var3 = this.getInput(var11);

                    if (var3 instanceof UpgradeData)
                    {
                        this.upgrades.combine((UpgradeData)var3);
                    }
                }

                this.RANGE = 10.0D + (double)this.upgrades.range;
                Set var12 = this.findAllPotentialTargets();

                if (var10 != null)
                {
                    var12 = var10.filter(var12);
                }

                this.currentTargets = var12;

                if (var12 != null && var12.size() > 0)
                {
                    Entity var13 = null;
                    double var4 = Double.MAX_VALUE;
                    Iterator var7 = this.currentTargets.iterator();

                    while (var7.hasNext())
                    {
                        Entity var6 = (Entity)var7.next();
                        double var8 = var6.e((double)this.x + 0.5D, (double)this.y + 0.5D, (double)this.z + 0.5D);

                        if (var8 < var4)
                        {
                            var4 = var8;
                            var13 = var6;
                        }
                    }

                    this.currentTarget = var13;

                    if (var13 != null)
                    {
                        this.fireShot(var13, this.eu_stored);
                    }
                }
                else
                {
                    this.currentTarget = null;
                }
            }

            --this.ticksToNextShot;
        }
    }

    private int getItemCollectionCost(EntityItem var1)
    {
        double var2 = var1.locX - ((double)this.x + 0.5D);
        double var4 = var1.locY - ((double)this.y + 0.5D);
        double var6 = var1.locZ - ((double)this.z + 0.5D);
        double var8 = var2 * var2 + var4 * var4 + var6 * var6;
        return (int)(var8 * 0.4D);
    }

    private void fireShot(Entity var1, int var2)
    {
        this.ticksToNextShot = Math.max(1, (int)(20.0D / this.upgrades.speed));

        if (var1 instanceof EntityItem)
        {
            if (var2 > 384)
            {
                var2 = 384;
            }

            this.ticksToNextShot = Math.min(this.ticksToNextShot, 3);
        }

        if (this.eu_stored < var2)
        {
            this.ticksToNextShot = 0;
        }
        else
        {
            this.eu_stored -= var2;
            int var3;
            int var5;

            if (var1 instanceof EntityHuman && this.upgrades.emp != null && this.upgrades.emp.storage > 0)
            {
                var3 = this.upgrades.emp.storage;
                PlayerInventory var4 = ((EntityHuman)var1).inventory;

                for (var5 = 0; var5 < 4 && var3 > 0; ++var5)
                {
                    ItemStack var6 = var4.armor[EMP_ARMOUR_PRIORITY[var5]];

                    if (var6 != null)
                    {
                        var3 -= ElectricItem.discharge(var6, var3, 9001, true, false);
                    }
                }

                this.upgrades.emp.storage = var3;
            }

            var3 = (int)(Math.sqrt((double)var2 / 5000.0D) * 30.0D);
            var1.damageEntity(damageSource, var3);

            if (this.upgrades.lootCollectors != null && var1 instanceof EntityItem && var1.dead)
            {
                EntityItem var9 = (EntityItem)var1;
                var5 = var9.itemStack.count;
                Iterator var7 = this.upgrades.lootCollectors.iterator();

                while (var7.hasNext())
                {
                    TileLootCollector var14 = (TileLootCollector)var7.next();

                    if (var14.collectItem(var9))
                    {
                        break;
                    }
                }

                if (var9.itemStack.count < var5)
                {
                    this.eu_stored -= this.getItemCollectionCost(var9);
                }
            }

            if (this.upgrades.potions != null && this.upgrades.potions.size() >= 1 && var1 instanceof EntityLiving)
            {
                TilePotionUpgrade var10 = (TilePotionUpgrade)this.upgrades.potions.iterator().next();
                Iterator var13 = var10.getEffect().iterator();

                while (var13.hasNext())
                {
                    MobEffect var12 = (MobEffect)var13.next();
                    ((EntityLiving)var1).addEffect(new MobEffect(var12));
                }
            }

            if (!this.upgrades.suppressor)
            {
                AxisAlignedBB var11 = var1.boundingBox;
                PacketBoltFX var15 = new PacketBoltFX((double)this.x + 0.5D, (double)this.y + 0.5D, (double)this.z + 0.5D, (var11.d + var11.a) / 2.0D, (var11.e + var11.b) / 2.0D, (var11.f + var11.c) / 2.0D);
                List var17 = this.world.a(EntityHuman.class, AxisAlignedBB.a((double)this.x, (double)this.y, (double)this.z, (double)this.x, (double)this.y, (double)this.z).d(0.5D, 0.5D, 0.5D).grow(100.0D, 100.0D, 100.0D));
                Iterator var8 = var17.iterator();

                while (var8.hasNext())
                {
                    EntityHuman var16 = (EntityHuman)var8.next();
                    OneTwoFiveNetworking.send("AdvRepSys", var15, var16);
                }
            }
        }
    }

    private Set findAllPotentialTargets()
    {
        double var1 = (double)this.x + 0.5D;
        double var3 = (double)this.y + 0.5D;
        double var5 = (double)this.z + 0.5D;
        double var7 = this.RANGE * this.RANGE;
        AxisAlignedBB var9 = AxisAlignedBB.a(var1 - this.RANGE, var3 - this.RANGE, var5 - this.RANGE, var1 + this.RANGE, var3 + this.RANGE, var5 + this.RANGE);
        HashSet var10 = new HashSet();
        Iterator var12 = this.world.a(Entity.class, var9).iterator();

        while (var12.hasNext())
        {
            Entity var11 = (Entity)var12.next();

            if ((!(var11 instanceof EntityLiving) || ((EntityLiving)var11).deathTicks <= 0) && !(var11 instanceof EntityPainting) && !(var11 instanceof EntityFallingBlock) && !(var11 instanceof EntityTNTPrimed) && var11.e(var1, var3, var5) <= var7)
            {
                var10.add(var11);
            }
        }

        return var10;
    }

    /**
     * invalidates a tile entity
     */
    public void j()
    {
        super.j();

        if (this.addedToENet)
        {
            EnergyNet.getForWorld(this.world).removeTileEntity(this);
            this.addedToENet = false;
        }
    }

    public boolean acceptsEnergyFrom(TileEntity var1, Direction var2)
    {
        return true;
    }

    public boolean isAddedToEnergyNet()
    {
        return this.addedToENet;
    }

    public boolean demandsEnergy()
    {
        return this.eu_stored < 5000;
    }

    public int injectEnergy(Direction var1, int var2)
    {
        if (this.eu_stored < 5000)
        {
            this.eu_stored += var2;
            return 0;
        }
        else
        {
            return var2;
        }
    }
}
