package immibis.ars.beams;

import immibis.ars.mod_AdvancedRepulsionSystems;
import immibis.core.BasicInventory;
import net.minecraft.server.EntityHuman;
import net.minecraft.server.IInventory;
import net.minecraft.server.ItemStack;
import net.minecraft.server.NBTTagCompound;

public class TileUpgradeUnit extends TileBeamEmitter implements IInventory
{
    public static final int SLOT_COL1 = 0;
    public static final int SLOT_COL2 = 6;
    public static final int SLOT_COL3 = 9;
    public static final int SLOT_FINAL = 10;
    private static TileUpgradeUnit.TopologyNode topology = new TileUpgradeUnit.TopologyNode(9, new TileUpgradeUnit.TopologyNode[] {new TileUpgradeUnit.TopologyNode(6, new TileUpgradeUnit.TopologyNode[]{new TileUpgradeUnit.TopologyNode(0, new TileUpgradeUnit.TopologyNode[0]), new TileUpgradeUnit.TopologyNode(1, new TileUpgradeUnit.TopologyNode[0])}), new TileUpgradeUnit.TopologyNode(7, new TileUpgradeUnit.TopologyNode[]{new TileUpgradeUnit.TopologyNode(2, new TileUpgradeUnit.TopologyNode[0]), new TileUpgradeUnit.TopologyNode(3, new TileUpgradeUnit.TopologyNode[0])}), new TileUpgradeUnit.TopologyNode(8, new TileUpgradeUnit.TopologyNode[]{new TileUpgradeUnit.TopologyNode(4, new TileUpgradeUnit.TopologyNode[0]), new TileUpgradeUnit.TopologyNode(5, new TileUpgradeUnit.TopologyNode[0])})});
    private BasicInventory inv = new BasicInventory(11);

    private LogicType getLTInSlot(int var1)
    {
        return LogicType.getForItem(this.inv.contents[var1]);
    }

    private EntityFilter buildFilter(TileUpgradeUnit.TopologyNode var1)
    {
        LogicType var2 = this.getLTInSlot(var1.filterSlot);

        if (var2 == null)
        {
            return null;
        }
        else
        {
            EntityFilter[] var3 = new EntityFilter[var1.inputs.length];

            for (int var4 = 0; var4 < var3.length; ++var4)
            {
                var3[var4] = this.buildFilter(var1.inputs[var4]);
            }

            return var2.createFilter(this, var3);
        }
    }

    public Object getOutput()
    {
        LogicType var1 = this.getLTInSlot(10);

        if (var1 == null)
        {
            return this.buildFilter(topology);
        }
        else
        {
            EntityFilter[] var2 = new EntityFilter[7];
            var2[0] = this.buildFilter(topology);

            for (int var3 = 0; var3 < 6; ++var3)
            {
                Object var4 = this.getInput(var3);

                if (var4 instanceof EntityFilter)
                {
                    var2[var3 + 1] = (EntityFilter)var4;
                }
            }

            return var1.createFilter(this, var2);
        }
    }

    /**
     * Allows the entity to update its state. Overridden in most subclasses, e.g. the mob spawner uses this to count
     * ticks and creates a new spawn inside its implementation.
     */
    public void q_()
    {
        if (!this.world.isStatic)
        {
            ;
        }
    }

    public boolean onBlockActivated(EntityHuman var1)
    {
        var1.openGui(mod_AdvancedRepulsionSystems.instance, 13, this.world, this.x, this.y, this.z);
        return true;
    }

    /**
     * Writes a tile entity to NBT.
     */
    public void b(NBTTagCompound var1)
    {
        super.b(var1);
        var1.set("inv", this.inv.writeToNBT());
    }

    /**
     * Reads a tile entity from NBT.
     */
    public void a(NBTTagCompound var1)
    {
        super.a(var1);
        this.inv.readFromNBT(var1.getList("inv"));
    }

    /**
     * Returns the number of slots in the inventory.
     */
    public int getSize()
    {
        return this.inv.contents.length;
    }

    /**
     * Returns the stack in slot i
     */
    public ItemStack getItem(int var1)
    {
        return this.inv.contents[var1];
    }

    /**
     * Decrease the size of the stack in slot (first int arg) by the amount of the second int arg. Returns the new
     * stack.
     */
    public ItemStack splitStack(int var1, int var2)
    {
        ItemStack var3 = this.inv.splitStack(var1, var2);
        return var3;
    }

    /**
     * When some containers are closed they call this on each slot, then drop whatever it returns as an EntityItem -
     * like when you close a workbench GUI.
     */
    public ItemStack splitWithoutUpdate(int var1)
    {
        return null;
    }

    /**
     * Sets the given item stack to the specified slot in the inventory (can be crafting or armor sections).
     */
    public void setItem(int var1, ItemStack var2)
    {
        this.inv.contents[var1] = var2;
    }

    /**
     * Returns the name of the inventory.
     */
    public String getName()
    {
        return "TileUpgradeUnit";
    }

    /**
     * Returns the maximum stack size for a inventory slot. Seems to always be 64, possibly will be extended. *Isn't
     * this more of a set than a get?*
     */
    public int getMaxStackSize()
    {
        return 64;
    }

    /**
     * Do not make give this method the name canInteractWith because it clashes with Container
     */
    public boolean a(EntityHuman var1)
    {
        return var1.e((double)this.x + 0.5D, (double)this.y + 0.5D, (double)this.z + 0.5D) <= 64.0D;
    }

    public void f() {}

    public void g() {}

    private static class TopologyNode
    {
        public final int filterSlot;
        public final TileUpgradeUnit.TopologyNode[] inputs;

        public TopologyNode(int var1, TileUpgradeUnit.TopologyNode ... var2)
        {
            this.filterSlot = var1;
            this.inputs = var2;
        }
    }
    
    @Override public ItemStack[] getContents() {return inv.contents;}
	@Override public void setMaxStackSize(int arg0) {}
}
